from typing import TypeVar

from rainbowadn.core.rainbow_factory import RainbowFactory

__all__ = ('Mentionable',)

Mentioned = TypeVar('Mentioned')


class Mentionable:
    def __bytes__(self):
        raise NotImplementedError

    def __factory__(self: Mentioned) -> RainbowFactory[Mentioned]:
        raise NotImplementedError

    def __topology_hash__(self) -> bytes:
        raise NotImplementedError
