from typing import Generic, TypeVar

from rainbowadn.core.rainbow_factory import RainbowFactory

__all__ = ('Origin',)

Mentioned = TypeVar('Mentioned')


class Origin(Generic[Mentioned]):
    def __init__(self, factory: RainbowFactory[Mentioned]):
        self.factory = factory

    async def resolve(self) -> Mentioned:
        raise NotImplementedError
