from typing import Generic, TypeVar

from rainbowadn.core.nullability.nullablereference import NullableReference

__all__ = ('CollectionInterface',)

CollectionType = TypeVar('CollectionType')


class CollectionInterface(
    Generic[CollectionType]
):
    def __init__(
            self,
            reference: NullableReference[CollectionType]
    ):
        assert isinstance(reference, NullableReference)
        self.reference = reference
